## moon 2.3

=== curl/CMakeLists.txt ===
# cURL/libcurl CMake script
# by Tetetest and Sukender (Benoit Neil)

# TODO:
# The output .so file lacks the soname number which we currently have within the lib/Makefile.am file
# Add full (4 or 5 libs) SSL support
# Add INSTALL target (EXTRA_DIST variables in Makefile.am may be moved to Makefile.inc so that CMake/CPack is aware of what's to include).
# Add CTests(?)
# Check on all possible platforms
# Test with as many configurations possible (With or without any option)
# Create scripts that help keeping the CMake build system up to date (to reduce maintenance). According to Tetetest:
#  - lists of headers that 'configure' checks for;
#  - curl-specific tests (the ones that are in m4/curl-*.m4 files);
#  - (most obvious thing:) curl version numbers.
# Add documentation subproject
#
# To check:
# (From Daniel Stenberg) The cmake build selected to run gcc with -fPIC on my box while the plain configure script did not.
# (From Daniel Stenberg) The gcc command line use neither -g nor any -O options. As a developer, I also treasure our configure scripts's --enable-debug option that sets a long range of "picky" compiler options.
cmake_minimum_required(VERSION 2.6.2 FATAL_ERROR)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake;${CMAKE_MODULE_PATH}")
include(Utilities)

project( CURL C )


file (READ ${CURL_SOURCE_DIR}/include/curl/curlver.h CURL_VERSION_H_CONTENTS)
string (REGEX MATCH "LIBCURL_VERSION_MAJOR[ \t]+([0-9]+)"
  LIBCURL_VERSION_MJ ${CURL_VERSION_H_CONTENTS})
string (REGEX MATCH "([0-9]+)"
  LIBCURL_VERSION_MJ ${LIBCURL_VERSION_MJ})
string (REGEX MATCH
  "LIBCURL_VERSION_MINOR[ \t]+([0-9]+)"
  LIBCURL_VERSION_MI ${CURL_VERSION_H_CONTENTS})
string (REGEX MATCH "([0-9]+)" LIBCURL_VERSION_MI ${LIBCURL_VERSION_MI})
string (REGEX MATCH
  "LIBCURL_VERSION_PATCH[ \t]+([0-9]+)"
  LIBCURL_VERSION_PT ${CURL_VERSION_H_CONTENTS})
string (REGEX MATCH "([0-9]+)" LIBCURL_VERSION_PT ${LIBCURL_VERSION_PT})
set (CURL_MAJOR_VERSION ${LIBCURL_VERSION_MJ})
set (CURL_MINOR_VERSION ${LIBCURL_VERSION_MI})
set (CURL_PATCH_VERSION ${LIBCURL_VERSION_PT})

include_regular_expression("^.*$")    # Sukender: Is it necessary?

# Setup package meta-data
# SET(PACKAGE "curl")
set(CURL_VERSION ${CURL_MAJOR_VERSION}.${CURL_MINOR_VERSION}.${CURL_PATCH_VERSION})
message(STATUS "curl version=[${CURL_VERSION}]")
# SET(PACKAGE_TARNAME "curl")
# SET(PACKAGE_NAME "curl")
# SET(PACKAGE_VERSION "-")
# SET(PACKAGE_STRING "curl-")
# SET(PACKAGE_BUGREPORT "a suitable curl mailing list => http://curl.haxx.se/mail/")
set(OPERATING_SYSTEM "${CMAKE_SYSTEM_NAME}")
set(OS "\"${CMAKE_SYSTEM_NAME}\"")

# Make the base headers visible to everything
# IF(NOT ${PROJECT_BINARY_DIR} EQUAL ${PROJECT_SOURCE_DIR})
# INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/include)
# ENDIF()
include_directories( ${CURL_SOURCE_DIR}/include )

if(WIN32)
  set(NATIVE_WINDOWS ON)
endif()

option(BUILD_CURL_EXE "Set to ON to build cURL executable." ON)
option(BUILD_CURL_TESTS "Set to ON to build cURL tests." ON)
option(CURL_STATICLIB "Set to ON to build libcurl with static linking." OFF)
option(CURL_USE_ARES "Set to ON to enable c-ares support" OFF)
# initialize CURL_LIBS
set(CURL_LIBS "")

if(CURL_USE_ARES)
  set(USE_ARES ${CURL_USE_ARES})
  find_package(CARES REQUIRED)
  list(APPEND CURL_LIBS ${CARES_LIBRARY} )
  set(CURL_LIBS ${CURL_LIBS} ${CARES_LIBRARY})
endif()

option(BUILD_DASHBOARD_REPORTS "Set to ON to activate reporting of cURL builds here http://www.cdash.org/CDashPublic/index.php?project=CURL" OFF)
if(BUILD_DASHBOARD_REPORTS)
  #INCLUDE(Dart)
  include(CTest)
endif(BUILD_DASHBOARD_REPORTS)

if(MSVC)
  option(BUILD_RELEASE_DEBUG_DIRS "Set OFF to build each configuration to a separate directory" OFF)
  mark_as_advanced(BUILD_RELEASE_DEBUG_DIRS)
endif()

option(CURL_HIDDEN_SYMBOLS "Set to ON to hide libcurl internal symbols (=hide all symbols that aren't officially external)." ON)
mark_as_advanced(CURL_HIDDEN_SYMBOLS)

# IF(WIN32)
# OPTION(CURL_WINDOWS_SSPI "Use windows libraries to allow NTLM authentication without openssl" ON)
# MARK_AS_ADVANCED(CURL_WINDOWS_SSPI)
# ENDIF()

option(HTTP_ONLY "disables all protocols except HTTP (This overrides all CURL_DISABLE_* options)" OFF)
mark_as_advanced(HTTP_ONLY)
option(CURL_DISABLE_FTP "disables FTP" OFF)
mark_as_advanced(CURL_DISABLE_FTP)
option(CURL_DISABLE_LDAP "disables LDAP" OFF)
mark_as_advanced(CURL_DISABLE_LDAP)
option(CURL_DISABLE_TELNET "disables Telnet" OFF)
mark_as_advanced(CURL_DISABLE_TELNET)
option(CURL_DISABLE_DICT "disables DICT" OFF)
mark_as_advanced(CURL_DISABLE_DICT)
option(CURL_DISABLE_FILE "disables FILE" OFF)
mark_as_advanced(CURL_DISABLE_FILE)
option(CURL_DISABLE_TFTP "disables TFTP" OFF)
mark_as_advanced(CURL_DISABLE_TFTP)
option(CURL_DISABLE_HTTP "disables HTTP" OFF)
mark_as_advanced(CURL_DISABLE_HTTP)

option(CURL_DISABLE_LDAPS "to disable LDAPS" OFF)
mark_as_advanced(CURL_DISABLE_LDAPS)
if(WIN32)
  set(CURL_DEFAULT_DISABLE_LDAP OFF)
  # some windows compilers do not have wldap32
  if( NOT HAVE_WLDAP32)
    set(CURL_DISABLE_LDAP ON CACHE BOOL "" FORCE)
    message(STATUS "wldap32 not found CURL_DISABLE_LDAP set ON")
    option(CURL_LDAP_WIN "Use W$ LDAP implementation" OFF)
  else()
    option(CURL_LDAP_WIN "Use W$ LDAP implementation" ON)
  endif()
  mark_as_advanced(CURL_LDAP_WIN)
  set(CURL_LDAP_HYBRID OFF)
else()
  option(CURL_LDAP_HYBRID "W$ LDAP with non-W$ compiler" OFF)
  mark_as_advanced(CURL_LDAP_HYBRID)
  set(CURL_LDAP_WIN OFF)
endif()

if(HTTP_ONLY)
  set(CURL_DISABLE_FTP ON)
  set(CURL_DISABLE_LDAP ON)
  set(CURL_DISABLE_TELNET ON)
  set(CURL_DISABLE_DICT ON)
  set(CURL_DISABLE_FILE ON)
  set(CURL_DISABLE_TFTP ON)
endif()

option(CURL_DISABLE_COOKIES "to disable cookies support" OFF)
mark_as_advanced(CURL_DISABLE_COOKIES)

option(CURL_DISABLE_CRYPTO_AUTH "to disable cryptographic authentication" OFF)
mark_as_advanced(CURL_DISABLE_CRYPTO_AUTH)
option(CURL_DISABLE_VERBOSE_STRINGS "to disable verbose strings" OFF)
mark_as_advanced(CURL_DISABLE_VERBOSE_STRINGS)
option(DISABLED_THREADSAFE "Set to explicitly specify we don't want to use thread-safe functions" OFF)
mark_as_advanced(DISABLED_THREADSAFE)
option(ENABLE_IPV6 "Define if you want to enable IPv6 support" OFF)
mark_as_advanced(ENABLE_IPV6)

if(WIN32)
  list_spaces_append_once(CMAKE_C_STANDARD_LIBRARIES wsock32.lib ws2_32.lib)  # bufferoverflowu.lib
  if(CURL_DISABLE_LDAP)
    # Remove wldap32.lib from space-separated list
    string(REPLACE " " ";" _LIST ${CMAKE_C_STANDARD_LIBRARIES})
    list(REMOVE_ITEM _LIST "wldap32.lib")
    to_list_spaces(_LIST CMAKE_C_STANDARD_LIBRARIES)
  else()
    # Append wldap32.lib
    list_spaces_append_once(CMAKE_C_STANDARD_LIBRARIES wldap32.lib)
  endif()
  set(CMAKE_C_STANDARD_LIBRARIES "${CMAKE_C_STANDARD_LIBRARIES}"   CACHE STRING "" FORCE)
endif()


# We need ansi c-flags, especially on HP
set(CMAKE_C_FLAGS "${CMAKE_ANSI_CFLAGS} ${CMAKE_C_FLAGS}")
set(CMAKE_REQUIRED_FLAGS ${CMAKE_ANSI_CFLAGS})

# Disable warnings on Borland to avoid changing 3rd party code.
if(BORLAND)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -w-")
endif(BORLAND)

# If we are on AIX, do the _ALL_SOURCE magic
if(${CMAKE_SYSTEM_NAME} MATCHES AIX)
  set(_ALL_SOURCE 1)
endif(${CMAKE_SYSTEM_NAME} MATCHES AIX)

# Include all the necessary files for macros
include (CheckFunctionExists)
include (CheckIncludeFile)
include (CheckIncludeFiles)
include (CheckLibraryExists)
include (CheckSymbolExists)
# if crosscompiling is on, the CHECK_TYPE_SIZE macro coming with cmake uses
# TRY_COMPILE instead of TRY_RUN which makes crosscompiling easier, Alex
if(CMAKE_CROSSCOMPILING)
  include ("${CMAKE_MODULE_PATH}/CheckTypeSize.cmake")
else(CMAKE_CROSSCOMPILING)
  include (CheckTypeSize)
endif(CMAKE_CROSSCOMPILING)

# On windows preload settings
if(WIN32)
  include(${CMAKE_CURRENT_SOURCE_DIR}/CMake/Platforms/WindowsCache.cmake)
endif(WIN32)

# This macro checks if the symbol exists in the library and if it
# does, it appends library to the list.
macro(CHECK_LIBRARY_EXISTS_CONCAT LIBRARY SYMBOL VARIABLE)
  check_library_exists("${LIBRARY};${CURL_LIBS}" ${SYMBOL} ""
    ${VARIABLE})
  if(${VARIABLE})
    set(CURL_LIBS ${CURL_LIBS} ${LIBRARY})
  endif(${VARIABLE})
endmacro(CHECK_LIBRARY_EXISTS_CONCAT)

# Check for all needed libraries
check_library_exists_concat("dl"     dlopen       HAVE_LIBDL)
#CHECK_LIBRARY_EXISTS_CONCAT("ucb"    gethostname  HAVE_LIBUCB)
check_library_exists_concat("socket" connect      HAVE_LIBSOCKET)
check_library_exists("c" gethostbyname "" NOT_NEED_LIBNSL)

# Yellowtab Zeta needs different libraries than BeOS 5.
if(BEOS)
  set(NOT_NEED_LIBNSL 1)
  check_library_exists_concat("bind" gethostbyname HAVE_LIBBIND)
  check_library_exists_concat("bnetapi" closesocket HAVE_LIBBNETAPI)
endif(BEOS)

if(NOT NOT_NEED_LIBNSL)
  check_library_exists_concat("nsl"    gethostbyname  HAVE_LIBNSL)
endif(NOT NOT_NEED_LIBNSL)

check_library_exists_concat("ws2_32" getch        HAVE_LIBWS2_32)
check_library_exists_concat("winmm"  getch        HAVE_LIBWINMM)
check_library_exists("wldap32" cldap_open "" HAVE_WLDAP32)

# IF(NOT CURL_SPECIAL_LIBZ)
#  CHECK_LIBRARY_EXISTS_CONCAT("z"      inflateEnd   HAVE_LIBZ)
# ENDIF(NOT CURL_SPECIAL_LIBZ)

option(CMAKE_USE_OPENSSL "Use OpenSSL code. Experimental" ON)
mark_as_advanced(CMAKE_USE_OPENSSL)
if(CMAKE_USE_OPENSSL)
  if(WIN32)
    find_package(OpenSSL)
    if(OPENSSL_FOUND)
      set(USE_SSLEAY TRUE)
      set(USE_OPENSSL TRUE)
      list(APPEND CURL_LIBS ${OPENSSL_LIBRARIES} )
    endif()
    #FIND_LIBRARY(LIBEAY NAMES libeay32)
    #LIST(APPEND CURL_LIBS ${LIBEAY} )
  else(WIN32)
    check_library_exists_concat("crypto" CRYPTO_lock  HAVE_LIBCRYPTO)
    check_library_exists_concat("ssl"    SSL_connect  HAVE_LIBSSL)
  endif(WIN32)
endif(CMAKE_USE_OPENSSL)

# Check for idn
check_library_exists_concat("idn" idna_to_ascii_lz HAVE_LIBIDN)

# Check for LDAP
check_library_exists_concat("ldap" ldap_init HAVE_LIBLDAP)
# if(NOT HAVE_LIBLDAP)
# SET(CURL_DISABLE_LDAP ON)
# endif(NOT HAVE_LIBLDAP)

# Check for symbol dlopen (same as HAVE_LIBDL)
check_library_exists("${CURL_LIBS}" dlopen "" HAVE_DLOPEN)

# For other tests to use the same libraries
set(CMAKE_REQUIRED_LIBRARIES ${CURL_LIBS})

option(CURL_ZLIB "Set to ON to enable building cURL with zlib support." ON)
set(HAVE_LIBZ OFF)
set(HAVE_ZLIB_H OFF)
set(HAVE_ZLIB OFF)
if(CURL_ZLIB)  # AND CURL_CONFIG_HAS_BEEN_RUN_BEFORE
  find_package(ZLIB QUIET)
  if(ZLIB_FOUND)
    set(HAVE_ZLIB_H ON)
    set(HAVE_ZLIB ON)
    set(HAVE_LIBZ ON)
  endif()
endif()

# If we have features.h, then do the _BSD_SOURCE magic
check_include_file("features.h"       HAVE_FEATURES_H)

# Check if header file exists and add it to the list.
macro(CHECK_INCLUDE_FILE_CONCAT FILE VARIABLE)
  check_include_files("${CURL_INCLUDES};${FILE}" ${VARIABLE})
  if(${VARIABLE})
    set(CURL_INCLUDES ${CURL_INCLUDES} ${FILE})
    set(CURL_TEST_DEFINES "${CURL_TEST_DEFINES} -D${VARIABLE}")
  endif(${VARIABLE})
endmacro(CHECK_INCLUDE_FILE_CONCAT)


# Check for header files
if(NOT UNIX)
  check_include_file_concat("ws2tcpip.h"     HAVE_WS2TCPIP_H)
  check_include_file_concat("winsock2.h"     HAVE_WINSOCK2_H)
endif(NOT UNIX)
check_include_file_concat("stdio.h"          HAVE_STDIO_H)
if(NOT UNIX)
  check_include_file_concat("windows.h"      HAVE_WINDOWS_H)
  check_include_file_concat("winsock.h"      HAVE_WINSOCK_H)
endif(NOT UNIX)

check_include_file_concat("inttypes.h"       HAVE_INTTYPES_H)
check_include_file_concat("sys/filio.h"      HAVE_SYS_FILIO_H)
check_include_file_concat("sys/ioctl.h"      HAVE_SYS_IOCTL_H)
check_include_file_concat("sys/param.h"      HAVE_SYS_PARAM_H)
check_include_file_concat("sys/poll.h"       HAVE_SYS_POLL_H)
check_include_file_concat("sys/resource.h"   HAVE_SYS_RESOURCE_H)
check_include_file_concat("sys/select.h"     HAVE_SYS_SELECT_H)
check_include_file_concat("sys/socket.h"     HAVE_SYS_SOCKET_H)
check_include_file_concat("sys/sockio.h"     HAVE_SYS_SOCKIO_H)
check_include_file_concat("sys/stat.h"       HAVE_SYS_STAT_H)

=== curl/Makefile ===
#***************************************************************************
#                                  _   _ ____  _
#  Project                     ___| | | |  _ \| |
#                             / __| | | | |_) | |
#                            | (__| |_| |  _ <| |___
#                             \___|\___/|_| \_\_____|
#
# Copyright (C) 1998 - 2009, Daniel Stenberg, <daniel@haxx.se>, et al.
#
# This software is licensed as described in the file COPYING, which
# you should have received as part of this distribution. The terms
# are also available at http://curl.haxx.se/docs/copyright.html.
#
# You may opt to use, copy, modify, merge, publish, distribute and/or sell
# copies of the Software, and permit persons to whom the Software is
# furnished to do so, under the terms of the COPYING file.
#
# This software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY
# KIND, either express or implied.
#
# $Id$
###########################################################################

VC=vc6

all:
	./configure
	make

ssl:
	./configure --with-ssl
	make

borland:
	cd lib
	make -f Makefile.b32
	cd ..\src
	make -f Makefile.b32

borland-ssl:
	cd lib
	make -f Makefile.b32 WITH_SSL=1
	cd ..\src
	make -f Makefile.b32 WITH_SSL=1

borland-ssl-zlib:
	cd lib
	make -f Makefile.b32 WITH_SSL=1 WITH_ZLIB=1
	cd ..\src
	make -f Makefile.b32 WITH_SSL=1 WITH_ZLIB=1

borland-clean:
	cd lib
	make -f Makefile.b32 clean
	cd ..\src
	make -f Makefile.b32 clean

watcom:
	cd lib
	wmake -f Makefile.Watcom
	cd ..\src
	wmake -f Makefile.Watcom

watcom-clean:
	cd lib
	wmake -f Makefile.Watcom clean
	cd ..\src
	wmake -f Makefile.Watcom clean

mingw32:
	$(MAKE) -C lib -f Makefile.m32
	$(MAKE) -C src -f Makefile.m32

mingw32-zlib:
	$(MAKE) -C lib -f Makefile.m32 ZLIB=1
	$(MAKE) -C src -f Makefile.m32 ZLIB=1

mingw32-ssl-zlib:
	$(MAKE) -C lib -f Makefile.m32 SSL=1 ZLIB=1
	$(MAKE) -C src -f Makefile.m32 SSL=1 ZLIB=1

mingw32-ssh2-ssl-zlib:
	$(MAKE) -C lib -f Makefile.m32 SSH2=1 SSL=1 ZLIB=1
	$(MAKE) -C src -f Makefile.m32 SSH2=1 SSL=1 ZLIB=1

mingw32-ssh2-ssl-sspi-zlib:
	$(MAKE) -C lib -f Makefile.m32 SSH2=1 SSL=1 SSPI=1 ZLIB=1
	$(MAKE) -C src -f Makefile.m32 SSH2=1 SSL=1 SSPI=1 ZLIB=1

mingw32-clean:
	$(MAKE) -C lib -f Makefile.m32 clean
	$(MAKE) -C src -f Makefile.m32 clean

vc-clean:
	cd lib
	nmake -f Makefile.$(VC) clean
	cd ..\src
	nmake -f Makefile.$(VC) clean

vc-all:
	cd lib
	nmake -f Makefile.$(VC) cfg=release
	nmake -f Makefile.$(VC) cfg=release-ssl
	nmake -f Makefile.$(VC) cfg=release-zlib
	nmake -f Makefile.$(VC) cfg=release-ssl-zlib
	nmake -f Makefile.$(VC) cfg=release-ssl-dll
	nmake -f Makefile.$(VC) cfg=release-zlib-dll
	nmake -f Makefile.$(VC) cfg=release-ssl-dll-zlib-dll
	nmake -f Makefile.$(VC) cfg=release-dll
	nmake -f Makefile.$(VC) cfg=release-dll-ssl-dll
	nmake -f Makefile.$(VC) cfg=release-dll-zlib-dll
	nmake -f Makefile.$(VC) cfg=release-dll-ssl-dll-zlib-dll
	nmake -f Makefile.$(VC) cfg=debug
	nmake -f Makefile.$(VC) cfg=debug-ssl
	nmake -f Makefile.$(VC) cfg=debug-zlib
	nmake -f Makefile.$(VC) cfg=debug-ssl-zlib
	nmake -f Makefile.$(VC) cfg=debug-ssl-dll
	nmake -f Makefile.$(VC) cfg=debug-zlib-dll
	nmake -f Makefile.$(VC) cfg=debug-ssl-dll-zlib-dll
	nmake -f Makefile.$(VC) cfg=debug-dll
	nmake -f Makefile.$(VC) cfg=debug-dll-ssl-dll
	nmake -f Makefile.$(VC) cfg=debug-dll-zlib-dll
	nmake -f Makefile.$(VC) cfg=debug-dll-ssl-dll-zlib-dll

vc:
	cd lib
	nmake /f Makefile.$(VC) cfg=release
	cd ..\src
	nmake /f Makefile.$(VC)

vc-x64:
	cd lib
	nmake /f Makefile.$(VC) MACHINE=x64 cfg=release
	cd ..\src
	nmake /f Makefile.$(VC) MACHINE=x64 cfg=release

vc-zlib:
	cd lib
	nmake /f Makefile.$(VC) cfg=release-zlib
	cd ..\src
	nmake /f Makefile.$(VC) cfg=release-zlib

vc-ssl:
	cd lib
	nmake /f Makefile.$(VC) cfg=release-ssl
	cd ..\src
	nmake /f Makefile.$(VC) cfg=release-ssl

vc-ssl-zlib:
	cd lib
	nmake /f Makefile.$(VC) cfg=release-ssl-zlib
	cd ..\src
	nmake /f Makefile.$(VC) cfg=release-ssl-zlib

vc-x64-ssl-zlib:
	cd lib
	nmake /f Makefile.$(VC) MACHINE=x64 cfg=release-ssl-zlib
	cd ..\src
	nmake /f Makefile.$(VC) MACHINE=x64 cfg=release-ssl-zlib

vc-ssl-dll:
	cd lib
	nmake /f Makefile.$(VC) cfg=release-ssl-dll
	cd ..\src
	nmake /f Makefile.$(VC) cfg=release-ssl-dll

vc-dll-ssl-dll:
	cd lib
	nmake /f Makefile.$(VC) cfg=release-dll-ssl-dll
	cd ..\src
	nmake /f Makefile.$(VC) cfg=release-dll-ssl-dll

vc-dll:
	cd lib
	nmake /f Makefile.$(VC) cfg=release-dll
	cd ..\src
	nmake /f Makefile.$(VC) cfg=release-dll

vc-dll-zlib-dll:
	cd lib
	nmake /f Makefile.$(VC) cfg=release-dll-zlib-dll
	cd ..\src
	nmake /f Makefile.$(VC) cfg=release-dll-zlib-dll

vc-dll-ssl-dll-zlib-dll:
	cd lib
	nmake /f Makefile.$(VC) cfg=release-dll-ssl-dll-zlib-dll
	cd ..\src
	nmake /f Makefile.$(VC) cfg=release-dll-ssl-dll-zlib-dll

vc-ssl-dll-zlib-dll:
	cd lib
	nmake /f Makefile.$(VC) cfg=release-ssl-dll-zlib-dll
	cd ..\src
	nmake /f Makefile.$(VC) cfg=release-ssl-dll-zlib-dll

vc-zlib-dll:
	cd lib
	nmake /f Makefile.$(VC) cfg=release-zlib-dll
	cd ..\src
	nmake /f Makefile.$(VC) cfg=release-zlib-dll

vc-sspi:
	cd lib
	nmake /f Makefile.$(VC) cfg=release WINDOWS_SSPI=1
	cd ..\src
	nmake /f Makefile.$(VC) cfg=release WINDOWS_SSPI=1

djgpp:
	$(MAKE) -C lib -f Makefile.dj
	$(MAKE) -C src -f Makefile.dj

cygwin:
	./configure
	make

cygwin-ssl:
	./configure --with-ssl
	make

amiga:
	cd ./lib && make -f makefile.amiga
	cd ./src && make -f makefile.amiga

netware:
	$(MAKE) -C lib -f Makefile.netware
	$(MAKE) -C src -f Makefile.netware

netware-ares:
	$(MAKE) -C lib -f Makefile.netware WITH_ARES=1
	$(MAKE) -C src -f Makefile.netware WITH_ARES=1

netware-ssl:
	$(MAKE) -C lib -f Makefile.netware WITH_SSL=1
	$(MAKE) -C src -f Makefile.netware WITH_SSL=1

netware-ssl-zlib:
	$(MAKE) -C lib -f Makefile.netware WITH_SSL=1 WITH_ZLIB=1
	$(MAKE) -C src -f Makefile.netware WITH_SSL=1 WITH_ZLIB=1

netware-ssh2-ssl-zlib:
	$(MAKE) -C lib -f Makefile.netware WITH_SSH2=1 WITH_SSL=1 WITH_ZLIB=1
	$(MAKE) -C src -f Makefile.netware WITH_SSH2=1 WITH_SSL=1 WITH_ZLIB=1

netware-zlib:
	$(MAKE) -C lib -f Makefile.netware WITH_ZLIB=1
	$(MAKE) -C src -f Makefile.netware WITH_ZLIB=1

netware-clean:
	$(MAKE) -C lib -f Makefile.netware clean
	$(MAKE) -C src -f Makefile.netware clean

netware-install:
	$(MAKE) -C lib -f Makefile.netware install
	$(MAKE) -C src -f Makefile.netware install

unix: all

unix-ssl: ssl

linux: all

linux-ssl: ssl


vc8: lib/Makefile.vc8 src/Makefile.vc8

lib/Makefile.vc8: lib/Makefile.vc6
	@echo "generate $@"
	@sed -e "s#/GX /DWIN32 /YX#/EHsc /DWIN32#" -e "s#/GZ#/RTC1#" -e "s/wsock32.lib/wsock32.lib bufferoverflowu.lib/g" -e "s/VC6/VC8/g" lib/Makefile.vc6 > lib/Makefile.vc8

src/Makefile.vc8: src/Makefile.vc6
	@echo "generate $@"
	@sed -e "s#/GX /DWIN32 /YX#/EHsc /DWIN32#" -e "s#/GZ#/RTC1#" -e "s/wsock32.lib/wsock32.lib bufferoverflowu.lib/g" -e "s/VC6/VC8/g" src/Makefile.vc6 > src/Makefile.vc8

# VC9 makefiles are for use with VS2008
vc9: lib/Makefile.vc9 src/Makefile.vc9

lib/Makefile.vc9: lib/Makefile.vc6
	@echo "generate $@"
	@sed -e "s#/GX /DWIN32 /YX#/EHsc /DWIN32#" -e "s#/GZ#/RTC1#" -e "s/wsock32.lib/ws2_32.lib/g" -e "s/vc6/vc9/g" -e "s/VC6/VC9/g" lib/Makefile.vc6 > lib/Makefile.vc9

src/Makefile.vc9: src/Makefile.vc6
	@echo "generate $@"
	@sed -e "s#/GX /DWIN32 /YX#/EHsc /DWIN32#" -e "s#/GZ#/RTC1#" -e "s/wsock32.lib/ws2_32.lib/g" -e "s/vc6/vc9/g" -e "s/VC6/VC9/g" src/Makefile.vc6 > src/Makefile.vc9

ca-bundle: lib/mk-ca-bundle.pl
	@echo "generate a fresh ca-bundle.crt"
	@perl $< -b -l -u lib/ca-bundle.crt

ca-firefox: lib/firefox-db2pem.sh
	@echo "generate a fresh ca-bundle.crt"
	./lib/firefox-db2pem.sh lib/ca-bundle.crt

=== mcs/class/Makefile ===
thisdir = class

bootstrap_dirs := \
	corlib					\
	Mono.CompilerServices.SymbolWriter	\
	System					\
	System.XML				\
	Mono.Security				\
	System.Security				\
	System.Configuration			\
	System


# Note that Mono.Security and System.Security aren't listed.
# We may have to add those if 'mcs' starts using them.
basic_SUBDIRS := corlib System System.XML System

net_1_1_java_SUBDIRS = \
	System.Xml					\
	System.Data					\
	System.Drawing					\
	Novell.Directory.Ldap				\
	System.DirectoryServices			\
	System.Runtime.Serialization.Formatters.Soap	\
	System.Runtime.Remoting

common_dirs := \
	corlib				\
	System				\
	System.XML			\
	Mono.CompilerServices.SymbolWriter \
	Mono.Posix			\
	System.Core			\
	Mono.Security			\
	System				\
	System.Security			\
	System.Configuration		\
	System				\
	System.XML			\
	I18N				\
	System.Drawing			\
	System.Transactions		\
	System.EnterpriseServices	\
	Mono.Data.Tds			\
	System.Data			\
	Mono.Data			\
	Mono.GetOptions			\
	Accessibility			\
	Mono.WebBrowser			\
	Managed.Windows.Forms		\
	Mono.Data.Sqlite		\
	Mono.Data.SqliteClient		\
	System.Web			\
	Mono.Web			\
	System.Web.Services		\
	System.Web			\
	System.Runtime.Serialization.Formatters.Soap \
	System.Runtime.Remoting		\
	System.Configuration.Install 	\
	System.Management		\
	Mono.Data.SybaseClient		\
	Mono.Data.TdsClient		\
	System.Data.OracleClient	\
	Microsoft.VisualC		\
	Cscompmgd			\
	System.Design			\
	PEAPI				\
	Npgsql				\
	Compat.ICSharpCode.SharpZipLib	\
	ICSharpCode.SharpZipLib		\
	Compat.ICSharpCode.SharpZipLib	\
	ByteFX.Data			\
	Commons.Xml.Relaxng		\
	Novell.Directory.Ldap		\
	Mono.Security.Win32		\
	System.DirectoryServices	\
	RabbitMQ.Client			\
	Mono.Messaging			\
	System.Messaging	        \
	Mono.Messaging.RabbitMQ		\
	System.ServiceProcess           \
	System.Drawing.Design		\
	System.Design			\
	Mono.Http			\
	Microsoft.Vsa			\
	Mono.Cairo                      \
	IBM.Data.DB2			\
	Microsoft.JScript		\
	CustomMarshalers		\
	OpenSystem.C			\
	Mono.Cecil			\
	Mono.Cecil.Mdb			\
	SystemWebTestShim

net_1_1_dirs :=		\
	FirebirdSql.Data.Firebird

net_2_0_dirs := \
	Microsoft.Build.Framework	\
	Microsoft.Build.Utilities	\
	Microsoft.Build.Engine		\
	Microsoft.Build.Tasks		\
	System.Xml.Linq			\
	System.Runtime.Serialization	\
	System.Data.DataSetExtensions	\
	System.Data.Linq		\
	System.Web			\
	System.Web.Abstractions		\
	System.Web.Routing		\
	System.IdentityModel		\
	System.IdentityModel.Selectors	\
	System.ServiceModel		\
	System.Web.Extensions		\
	System.Web.Extensions.Design	\
	System.ComponentModel.DataAnnotations	\
	System.Web.DynamicData		\
	System.ServiceModel.Web		\
	System.Web.Mvc			\
	Mono.C5				\
	Mono.Management			\
	Mono.Options 			\
	Mono.Simd			\
	Mono.Tasklets       		\
	WindowsBase			\
	Mono.Debugger.Soft	\
	System.Data.Services

net_2_0_only_dirs := \
	System.Web.Extensions_1.0	\
	System.Web.Extensions.Design_1.0

net_2_1_dirs := \
	corlib			\
	Mono.CompilerServices.SymbolWriter \
	System			\
	System.XML		\
	System.Core		\
	System.Net		\
	System.Xml.Linq	\
	System.Runtime.Serialization	\
	System.ServiceModel	\
	System.ServiceModel.Web

monotouch_dirs := \
	corlib	\
	Mono.CompilerServices.SymbolWriter	\
	System	\
	System.XML	\
	Mono.Security	\
	System	\
	I18N		\
	System.Core	\
	System.Json	\
	System.Xml.Linq	\
	System.Runtime.Serialization	\
	System.ServiceModel	\
	System.ServiceModel.Web	\
	System.Web.Services	\
	Mono.Data.Tds	\
	System.Transactions	\
	System.Data	\
	Mono.Data.Sqlite

net_3_5_dirs := \
	Microsoft.Build.Framework	\
	Microsoft.Build.Utilities	\
	Microsoft.Build.Engine		\
	Microsoft.Build.Tasks		\
	System.Web.Extensions.Design	

net_4_0_dirs := \
	System.Dynamic		\
	Microsoft.CSharp

net_1_1_bootstrap_SUBDIRS := $(bootstrap_dirs) PEAPI
net_1_1_SUBDIRS := $(common_dirs) $(net_1_1_dirs)
net_2_0_bootstrap_SUBDIRS := $(bootstrap_dirs) PEAPI
net_2_0_SUBDIRS := $(common_dirs) $(net_2_0_dirs) $(net_2_0_only_dirs)
net_2_1_bootstrap_SUBDIRS := corlib System Mono.CompilerServices.SymbolWriter
net_2_1_raw_SUBDIRS := $(net_2_1_dirs)
monotouch_bootstrap_SUBDIRS := corlib System Mono.CompilerServices.SymbolWriter
monotouch_SUBDIRS := $(monotouch_dirs)
net_3_5_SUBDIRS := $(net_3_5_dirs)
net_4_0_bootstrap_SUBDIRS := $(bootstrap_dirs) PEAPI Mono.Posix System.Core
net_4_0_SUBDIRS := $(common_dirs) $(net_2_0_dirs) $(net_4_0_dirs)

include ../build/rules.make

SUBDIRS = $(common_dirs) $(net_1_1_dirs) $(net_2_0_dirs) $(net_2_0_only_dirs) $(net_2_1_dirs) $(net_3_5_dirs) $(net_4_0_dirs)

DIST_ONLY_SUBDIRS = dlr

# No new makefiles for: System.Messaging, System.Web.Mobile,
# System.ServiceProcess

DISTFILES = \
	ecma.pub		\
	winfx.pub		\
	winfx3.pub		\
	mono.pub		\
	msfinal.pub		\
	silverlight.pub		\
	mono.snk		\
	LICENSE 		\
	README			\
	doc/API-notes		\
	doc/NUnitGuidelines	\
	doc/TemplateTest.cs	\
	notes/BitVecto32.txt	\
	MicrosoftAjaxLibrary/License.htm	\
	$(monolite_files)

.PHONY: all-local $(STD_TARGETS:=-local)
all-local $(STD_TARGETS:=-local):
	@:

basic_files = mcs.exe mscorlib.dll System.dll System.Xml.dll
monolite_files = $(basic_files:%=lib/monolite/%)

lib/monolite:
	$(MKINSTALLDIRS) $@

$(monolite_files): | lib/monolite
$(monolite_files): lib/monolite/%: lib/basic/%
	cp -p $< $@

$(basic_files:%=lib/basic/%):
	cd $(topdir) && $(MAKE) profile-do--basic--all

dist-default: $(monolite_files)
dist-local: dist-default

csproj-local:

=== mcs/docs/Makefile ===
thisdir = docs
SUBDIRS = 
include ../build/rules.make

DISTFILES = \
	clr-abi.txt                 \
	compiler.txt                \
	control-flow-analysis.txt   \
	cs-errors.config            \
	monodoc.xml                 \
	new-anonymous-design.txt    \
	order.txt                   \
	$(DOC_SOURCE_FILES)         \
	$(wildcard ecma334/*.xml)

DOC_SOURCE_FILES = \
	lang-csharp.source          \
	Mono.source                 \
	netdocs.source              \
	Novell.source

ASSEMBLED_DOCS = \
	cs-errors.tree cs-errors.zip      \
	ecma334.tree ecma334.zip          \
	Mono.tree Mono.zip                \
	netdocs.tree netdocs.zip          \
	Novell.tree Novell.zip            

MONODOC_SOURCES_INSTALL_FILES = \
	$(ASSEMBLED_DOCS)             \
	$(DOC_SOURCE_FILES)

CLEAN_FILES += $(ASSEMBLED_DOCS)

ifeq (net_2_0, $(PROFILE))
all-local: build-documentation
endif

all-local test-local run-test-local run-test-ondotnet-local doc-update:

clean-local:
	-rm -f $(CLEAN_FILES)

dist-local: dist-default


MONODOC_INSTALL_DIR = $(DESTDIR)$(mono_libdir)/monodoc

ifdef DISABLE_MCS_DOCS
install-local:

uninstall-local:

else
install-local:
	$(MKINSTALLDIRS) $(MONODOC_INSTALL_DIR) $(MONODOC_INSTALL_DIR)/sources
	$(INSTALL_DATA) $(MONODOC_SOURCES_INSTALL_FILES) $(MONODOC_INSTALL_DIR)/sources
	$(INSTALL_DATA) monodoc.xml $(MONODOC_INSTALL_DIR)

uninstall-local:
	-rm -f $(MONODOC_INSTALL_DIR)/monodoc.xml
	-rm -f $(addprefix $(MONODOC_INSTALL_DIR)/sources/,$(MONODOC_SOURCES_INSTALL_FILES))
endif



classdir = $(topdir)/class
doc_en   = Documentation/en

NETDOCS_DIRS = \
	$(classdir)/corlib/$(doc_en)                                        \
	$(classdir)/Microsoft.Build.Engine/$(doc_en)                        \
	$(classdir)/Microsoft.Build.Framework/$(doc_en)                     \
	$(classdir)/Microsoft.Build.Utilities/$(doc_en)                     \
	$(classdir)/System.Configuration.Install/$(doc_en)                  \
	$(classdir)/System.Core/$(doc_en)                                   \
	$(classdir)/System.Data/$(doc_en)                                   \
	$(classdir)/System.Design/$(doc_en)                                 \
	$(classdir)/System.DirectoryServices/$(doc_en)                      \
	$(classdir)/System.Drawing/$(doc_en)                                \
	$(classdir)/System.Runtime.Remoting/$(doc_en)                       \
	$(classdir)/System.Runtime.Serialization.Formatters.Soap/$(doc_en)  \
	$(classdir)/System.Security/$(doc_en)                               \
	$(classdir)/System.Web.Services/$(doc_en)                           \
	$(classdir)/System.Web/$(doc_en)                                    \
	$(classdir)/System.XML/$(doc_en)                                    \
	$(classdir)/System/$(doc_en)                                        \

MONO_DIRS = \
	$(classdir)/Commons.Xml.Relaxng/$(doc_en)          \
	$(classdir)/Mono.Cairo/$(doc_en)                   \
	$(classdir)/Mono.Data.SqliteClient/$(doc_en)       \
	$(classdir)/Mono.GetOptions/$(doc_en)              \
	$(classdir)/Mono.Options/$(doc_en)                 \
	$(classdir)/Mono.Posix/$(doc_en)                   \
	$(classdir)/Mono.Security.Win32/$(doc_en)          \
	$(classdir)/Mono.Security/$(doc_en)                \
	$(classdir)/Mono.Simd/$(doc_en)                    \
	$(classdir)/Npgsql/$(doc_en)                       \
	$(topdir)/tools/csharplib/en

NOVELL_DIRS = \
	$(topdir)/class/Novell.Directory.Ldap/Documentation/en

NUNIT_DIRS = \
	$(topdir)/nunit20/core/$(doc_en)       \
	$(topdir)/nunit20/framework/$(doc_en)  \
	$(topdir)/nunit20/mocks/$(doc_en)      \
	$(topdir)/nunit20/util/$(doc_en)

ifdef DISABLE_MCS_DOCS
build-documentation:
else
build-documentation: $(ASSEMBLED_DOCS)
endif

# To support `make -jN`, we can't mention multiple targets in the same rule;
# DO NOT DO THIS:
#
#	  foo.tree foo.zip : Makefile
#     $(MDOC) assemble -o foo $(FOO_DIRS)
#
# If you do, make will try to biuld foo.tree & foo.zip concurrently, which
# breaks things badly... (read: "mdoc: sharing violation on path...foo.zip").
#
# The proper solution is to chain the rule dependencies so that only one file
# is the target of a rule.

netdocs.zip : netdocs.tree
netdocs.tree: Makefile
	$(MDOC) assemble -o netdocs $(NETDOCS_DIRS)

Mono.zip : Mono.tree
Mono.tree: Makefile
	$(MDOC) assemble -o Mono $(MONO_DIRS)

Novell.zip : Novell.tree
Novell.tree: Makefile
	$(MDOC) assemble -o Novell $(NOVELL_DIRS)

cs-errors.zip : cs-errors.tree
cs-errors.tree: cs-errors.config Makefile
	$(MDOC) assemble -o cs-errors -f error $<

ecma334.zip : ecma334.tree
ecma334.tree: Makefile
	$(MDOC) assemble -o ecma334 -f ecmaspec ecma334

=== mcs/errors/Makefile ===
thisdir = errors
SUBDIRS = 
include ../build/rules.make

with_mono_path = MONO_PATH="$(topdir)/class/lib/$(PROFILE)$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH"

ifeq (net_1_1, $(PROFILE))
# force this, we don't case if CSC is broken. This also
# means we can use --options, yay.

MCS = $(with_mono_path) $(INTERNAL_MCS)
else
EXTRA_SUPPORT_FILES = CSFriendAssembly-lib.dll GCS0122-2-lib.dll GCS0730-lib.dll GCS0733-lib.dll GCS1685-lib.dll
endif

ilasm = $(topdir)/class/lib/$(PROFILE)/ilasm.exe
ILASM = $(with_mono_path) $(RUNTIME) $(RUNTIME_FLAGS) $(ilasm)

DISTFILES = \
	CONTRIBUTORS_README 	\
	errors.txt 		\
	do-tests.pl		\
	$(wildcard *.cs)	\
	$(wildcard *.il)	\
	$(wildcard *.inc)	\
	$(wildcard *.pub)	\
	$(wildcard *.snk)	\
	$(wildcard *.response)	\
	$(wildcard known-issues-*)

TEST_SUPPORT_FILES = \
	CS0118-2-lib.dll CS0122-10-lib.dll CS0122-14-lib.dll CS0122-15-lib.dll CS0122-19-lib.dll CS0144-3-lib.dll \
	CS0205-3-lib.dll \
	CS0229-3-lib.dll CS0229-4-lib.dll \
	CS0433-lib.dll CS0433-2-lib.dll \
	CS0534-3-lib.dll CS0534-4-lib.dll CS0571-3-lib.dll CS0571-5-lib.dll CS0571-6-lib.dll \
	CS0612-2-lib.dll CS0618-2-lib.dll CS0619-8-lib.dll CS0619-17-lib.dll CS0619-32-lib.dll CS0619-33-lib.dll CS0619-36-lib.dll CS0619-42-lib.dll \
	CS0619-43-lib.dll CS1546-lib.dll CS0619-51-lib.dll CS1509-module.dll CS1681-2-lib.dll \
	CS2015-lib.dll CS3005-16-lib.dll CS3013-module.dll CSExternAlias-lib.dll \
	$(EXTRA_SUPPORT_FILES) 

# mention all targets
all-local $(STD_TARGETS:=-local):

VALID_PROFILE := $(filter net_1_1 net_2_0 net_2_1 net_4_0, $(PROFILE))
ifdef VALID_PROFILE

check: run-mcs-tests 

# again, run-test is when the tests actually happen, so
# don't compile on make test.

test-local:
	@:

run-test-local: clean-local
	$(MAKE) run-mcs-tests

test-everything:
	$(MAKE) PROFILE=net_1_1 run-test
	$(MAKE) PROFILE=net_2_0 run-test

ifeq (net_4_0, $(PROFILE))
COMPILER_NAME = dmcs
TEST_PATTERN = '*cs*.cs'
endif
ifeq (net_2_1, $(PROFILE))
COMPILER_NAME = smcs
TEST_PATTERN = '*cs*.cs'
LOCAL_RUNTIME_FLAGS = --security=temporary-smcs-hack
endif
ifeq (net_2_0, $(PROFILE))
COMPILER_NAME = gmcs
TEST_PATTERN = '*cs*.cs'
endif
ifeq (net_1_1, $(PROFILE))
COMPILER_NAME = mcs
TEST_PATTERN = 'cs*.cs'
endif

COMPILER = $(topdir)/class/lib/$(PROFILE)/$(COMPILER_NAME).exe
TESTER = MONO_RUNTIME='$(RUNTIME)' $(TEST_RUNTIME) $(RUNTIME_FLAGS) $(LOCAL_RUNTIME_FLAGS) $(topdir)/class/lib/$(PROFILE)/compiler-tester.exe

run-mcs-tests: $(TEST_SUPPORT_FILES)
	$(TESTER) -mode:neg -files:$(TEST_PATTERN) -compiler:$(COMPILER) -issues:known-issues-$(COMPILER_NAME) -log:$(COMPILER_NAME).log $(TESTER_OPTIONS)

cecil:
	$(TESTER) -mode:neg -files:$(TEST_PATTERN) -compiler:../tests/gmcs.exe -issues:known-issues-$(COMPILER_NAME) -log:$(COMPILER_NAME).log $(TESTER_OPTIONS) -verbose

clean-local:
	rm -f *.exe *.dll *.log *.mdb dummy.xml *.junk

dist-local: dist-default

install-local uninstall-local:

%-lib.dll: %-lib.cs
	$(CSCOMPILE) /target:library /out:$@ $<

%-module.dll: %-module.cs
	$(CSCOMPILE) /target:module /out:$@ $<

%-lib.dll: %-lib.il
	$(ILASM) /dll /out:$@ $<

endif

=== mcs/class/Commons.Xml.Relaxng/Makefile ===
thisdir = class/Commons.Xml.Relaxng
SUBDIRS = 
include ../../build/rules.make

RESOURCE_FILES = resources/relaxng.rng

OTHER_RES = $(RESOURCE_FILES)

LIBRARY = Commons.Xml.Relaxng.dll
LIB_MCS_FLAGS = /r:$(corlib) /r:System.dll /r:System.Xml.dll \
	$(foreach r, $(OTHER_RES), /resource:$(r),$(notdir $(r)))
TEST_MCS_FLAGS = $(LIB_MCS_FLAGS) -nowarn:0618 -nowarn:219 -nowarn:169
EXTRA_DISTFILES = \
	Commons.Xml.Relaxng.Rnc/RncParser.jay	\
	Test/ChangeLog		\
	Test/XmlFiles/ChangeLog	\
	$(wildcard Test/XmlFiles/*.rng) \
	$(wildcard Test/XmlFiles/*.rnc) \
	$(wildcard Test/XmlFiles/*.nvdl) \
	$(wildcard Test/XmlFiles/*.xml) \
	$(wildcard Test/standalone_tests/*.cs) \
	$(RESOURCE_FILES)

Commons.Xml.Relaxng.Rnc/RncParser.cs: Commons.Xml.Relaxng.Rnc/RncParser.jay $(topdir)/jay/skeleton.cs
	$(topdir)/jay/jay -ctv < $(topdir)/jay/skeleton.cs Commons.Xml.Relaxng.Rnc/RncParser.jay > Commons.Xml.Relaxng.Rnc/RncParser.cs

BUILT_SOURCES = Commons.Xml.Relaxng.Rnc/RncParser.cs

include ../../build/library.make

$(the_lib): $(OTHER_RES)

=== mcs/class/FirebirdSql.Data.Firebird/Makefile ===
thisdir = class/FirebirdSql.Data.Firebird
SUBDIRS =
include ../../build/rules.make

LIBRARY = FirebirdSql.Data.Firebird.dll
LIBRARY_SNK = FirebirdSql.Data.Firebird.snk

LIB_DEFINE_FLAGS = 

ifeq ($(PLATFORM), linux)
LIB_DEFINE_FLAGS = /d:LINUX
endif

LIB_MCS_FLAGS = \
	$(LIB_DEFINE_FLAGS) \
	/r:$(corlib) /r:System.dll \
	/r:System.Xml.dll /r:System.Data.dll \
	/r:System.Drawing \
	@FirebirdSql.Data.Firebird.dll.resources

TEST_MCS_FLAGS = /r:$(corlib) /r:System.dll \
	/r:System.Xml.dll /r:System.Data.dll \

EXTRA_DISTFILES = \
	license.txt \
	license.html \
	readme.txt \
	changelog.txt \
	FirebirdSql.Data.Firebird.snk \
	FirebirdSql.Data.Firebird.dll.resources \
	FirebirdSql.Data.Common/Resources/isc_error_msg.resources \
	FirebirdSql.Data.Firebird.dll.resources \
	Test/App.config \
	Test/AssemblyInfo.cs \
	Test/BaseTest.cs \
	Test/FbArrayTest.cs \
	Test/FbBlobTest.cs \
	Test/FbCommandBuilderTest.cs \
	Test/FbCommandTest.cs \
	Test/FbConnectionTest.cs \
	Test/FbDataAdapterTest.cs \
	Test/FbDatabaseInfoTest.cs \
	Test/FbDatabaseSchemaTest.cs \
	Test/FbDataReaderTest.cs \
	Test/FbImplicitTransactionTest.cs \
	Test/FbParameterCollectionTest.cs \
	Test/FbParameterTest.cs \
	Test/FbScriptTest.cs \
	Test/FbServicesTests.cs \
	Test/FbStoredProcCallsTest.cs \
	Test/FbTransactionTest.cs \
	Test/GuidTest.cs \

include ../../build/library.make

=== mcs/class/Managed.Windows.Forms/Makefile ===
thisdir = class/Managed.Windows.Forms
include ../../build/rules.make

LIBRARY = System.Windows.Forms.dll

LIB_MCS_FLAGS = /unsafe \
	/r:$(corlib) /r:System.dll /r:System.Xml.dll \
	/r:System.Drawing.dll /r:Accessibility.dll \
	/r:System.Data.dll /r:Mono.Posix.dll \
	/r:Mono.WebBrowser \
	@System.Windows.Forms.dll.resources \
	-debug -nowarn:618,612,809

ifneq (1, $(FRAMEWORK_VERSION_MAJOR))
LIB_MCS_FLAGS += /r:System.Configuration.dll
endif

ifeq (true, $(GENERATE_RESOURCES))
LIB_MCS_FLAGS += /define:GENERATING_RESOURCES
endif

RESX_RESOURCES = \
	resources/keyboards.resources

CUR_RESOURCES = resources/NWSE.cur resources/NESW.cur \
	resources/SplitterNS.cur \
	resources/SplitterWE.cur \
	resources/NWSE.cur \
	resources/NESW.cur \
	resources/DnDNo.cur \
	resources/DnDCopy.cur \
	resources/DnDLink.cur \
	resources/DnDMove.cur

RESOURCES = $(RESX_RESOURCES) $(CUR_RESOURCES)

PREBUILT = $(RESX_RESOURCES:=.prebuilt)

IMAGES_RESOURCES = \
	resources/16_computer.png		\
	resources/32_computer.png		\
	resources/computer.png			\
	resources/16_document-open.png		\
	resources/32_document-open.png		\
	resources/document-open.png		\
	resources/16_folder.png			\
	resources/folder-new.png		\
	resources/folder.png			\
	resources/16_folder-remote.png		\
	resources/32_folder-remote.png		\
	resources/folder-remote.png		\
	resources/go-previous.png		\
	resources/go-top.png			\
	resources/22_page-magnifier.png		\
	resources/preferences-system-windows.png\
	resources/16_printer.png		\
	resources/32_printer.png		\
	resources/text-x-generic.png		\
	resources/16_user-desktop.png		\
	resources/32_user-desktop.png		\
	resources/user-desktop.png		\
	resources/16_user-home.png		\
	resources/32_user-home.png		\
	resources/user-home.png		\
	resources/16_dialog-error.png		\
	resources/16_dialog-information.png	\
	resources/16_dialog-warning.png		\
	resources/1-up.png			\
	resources/2-up.png			\
	resources/3-up.png			\
	resources/4-up.png			\
	resources/6-up.png			\
	resources/nav_delete.png		\
	resources/nav_end.png			\
	resources/nav_first.png			\
	resources/nav_previous.png		\
	resources/nav_next.png			\
	resources/nav_plus.png			\
	resources/image-missing.png		\
	resources/image-x-generic.png		\
	resources/propertygrid-alphabetical.png	\
	resources/propertygrid-categorized.png	\
	resources/EventsTab.bmp			\
	resources/PropertiesTab.bmp 		\
	resources/propertygrid-propertypages.png	\
	resources/mono.ico			\
	resources/errorProvider.ico


TEST_DISTFILES = \
	M.gif \
	Test/resources/a.cur \
	Test/resources/32x32.ico \
	Test/System.Resources/compat_1_1.resx \
	Test/System.Resources/compat_2_0.resx \
	Test/System.Windows.Forms/bitmaps/a.png

EXTRA_DISTFILES = \
	README System.Windows.Forms.dll.resources \
	$(RESX_RESOURCES:.resources=.resx) $(CUR_RESOURCES) $(PREBUILT) build-csproj build-csproj2k5 \
	$(IMAGES_RESOURCES) \
	$(TEST_DISTFILES)

TEST_MCS_FLAGS = /r:System.Data.dll /r:System.Drawing.dll \
	-resource:Test/resources/a.cur,a.cur \
	-resource:Test/resources/32x32.ico,32x32.ico \
	-nowarn:618,612

include ../../build/library.make

TEST_HARNESS_EXCLUDES = -exclude=Interactive,NotWorking,ValueAdd,CAS,InetAccess
TEST_HARNESS_EXCLUDES_ONDOTNET = -exclude=Interactive,NotDotNet,CAS

$(the_lib): $(RESOURCES)

$(RESX_RESOURCES): %.resources: %.resx
	$(RESGEN) $< || cp $@.prebuilt $@

$(LIBRARY): $(CUR_RESOURCES)

$(PREBUILT): %.prebuilt: %
	cp $* $@

dist-default: $(PREBUILT)

=== mcs/class/Microsoft.Build.Tasks/Makefile ===
thisdir = class/Microsoft.Build.Tasks
SUBDIRS = 
include ../../build/rules.make

LIBRARY = Microsoft.Build.Tasks.dll
ifeq (1.0, $(FRAMEWORK_VERSION))

LIBRARY_NAME = dummy-Microsoft.Build.Tasks.dll
NO_INSTALL = yes
NO_TEST = yes
NO_SIGN_ASSEMBLY = yes

else

ifeq (3.5, $(FRAMEWORK_VERSION))
NAME_SUFFIX = .v3.5
endif

LIBRARY_NAME = Microsoft.Build.Tasks$(NAME_SUFFIX).dll

endif

LIB_MCS_FLAGS = \
	/r:$(corlib)				\
	/r:System.dll				\
	/r:System.Core.dll			\
	/r:System.Xml.dll			\
	/r:System.Windows.Forms.dll		\
	/r:Microsoft.Build.Utilities.dll	\
	/r:Microsoft.Build.Framework.dll	\
	/r:Microsoft.Build.Engine.dll

TEST_MCS_FLAGS = \
	/r:Microsoft.Build.Engine.dll		\
	/r:Microsoft.Build.Framework.dll	\
	/r:Microsoft.Build.Utilities$(NAME_SUFFIX).dll

EXTRA_DISTFILES = \
	Test/resources/test.cs \
	Test/resources/Sample.cs \
	Test/resources/Sample.vb

test-local: Test/resources/test.dll

Test/resources/test.dll: Test/resources/test.cs
	$(CSCOMPILE) -target:library Test/resources/test.cs

include ../../build/library.make

=== mcs/class/Microsoft.CSharp/Makefile ===
thisdir = class/Microsoft.CSharp
SUBDIRS = 
include ../../build/rules.make

LIBRARY = Microsoft.CSharp.dll

LIB_MCS_FLAGS = -r:System.Core.dll -r:dmcs.exe

include ../../build/library.make

=== mcs/class/Mono.Posix/Makefile ===
thisdir = class/Mono.Posix
SUBDIRS = 
include ../../build/rules.make

LIBRARY = Mono.Posix.dll
# Don't warn about [Obsolete] members, as there are now *lots* of [Obsolete]
# members, generating volumes of output.
LIB_MCS_FLAGS = /unsafe /r:$(corlib) /r:System.dll /nowarn:0618,612
TEST_MCS_FLAGS = /r:Mono.Posix.dll /r:System.dll /nowarn:0219,0618

ifeq (net_4_0, $(PROFILE))
USE_BOOT_COMBILE = yes
LIBRARY_COMPILE = $(BOOT_COMPILE)
endif

include ../../build/library.make

update-mappings:
	cp `pkg-config --variable=Sources create-native-map` Mono.Unix.Native
	cp `pkg-config --variable=Programs create-native-map` Mono.Unix.Native
	mono --debug Mono.Unix.Native/create-native-map.exe \
		--library=MonoPosixHelper \
		--rename-namespace Mono.Unix.Native=Mono.Posix \
		$(the_lib) Mono.Unix.Native/NativeConvert.generated

=== mcs/class/OpenSystem.C/Makefile ===
thisdir = class/OpenSystem.C
SUBDIRS = 
include ../../build/rules.make

LIBRARY = OpenSystem.C.dll
NO_TEST = yes

include ../../build/library.make

=== debian/changelog ===
moon (2.3-0ubuntu5) natty; urgency=low

  * Fix LP: #538796 - cannot open Firefox/Chromium/Chrome when moonlight
    is installed, due to a symbol collision with the icedtea plugin. Thanks
    to Evan Martin and Chris Toshok for figuring this out
    - add debian/patches/avoid_icedtea_symbol_collision.patch
    - update debian/patches/series
  * Fix build with xulrunner 2.0
    - add debian/patches/xulrunner_20.patch
    - update debian/patches/series

 -- Chris Coulson <chris.coulson@canonical.com>  Mon, 31 Jan 2011 16:04:45 +0000

moon (2.3-0ubuntu4) maverick; urgency=low

  * ARM development made possible by Genesi USA
  * add_arm_to_firefox-xpi.m4.patch:
    + For reasons best known to themselves, Mozilla don't define a 
      plugin ABI for several platforms, including ARM. This patch 
      tweaks the build system not to fail on ARM, by setting the 
      bogus Linux_unknownABI ABI on ARM, rather than bailing out.
      (LP: #635406)
  * realign_nocodec_API_with_codec_API.patch:
    + Import upstream git commit 66993b158727585e889d, which fixes 
      the build on architectures without official binary codecs 
      available (such as ARM and PowerPC).

 -- Jo Shields <directhex@apebox.org>  Mon, 04 Oct 2010 20:58:14 +0100

moon (2.3-0ubuntu3) maverick; urgency=low

  * Fix the check for GC_test_and_set and GC_clear on armel. The sync
    primitives are backported to the gcc-4.4 package. Fixes the
    build failure on armel in thumb mode. LP: #635406.
  * Apply arm related patches from the mono package.
  * Configure with --build= --host=.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 19 Sep 2010 18:30:15 +0200

moon (2.3-0ubuntu2) maverick; urgency=low

  * mono-2.6/libgc/include/private/gc_locks.h: For __ARM_EABI__ define
    GC_test_and_set and GC_clear to use the atomic builtins.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 19 Sep 2010 14:30:56 +0200

moon (2.3-0ubuntu1) maverick; urgency=low

  * New upstream release
  * The "Ubuntu UK Podcast" release
  * debian/control,
    debian/rules:
    + Build-depend on chromium-browser
    + Build against libcurl, for Chromium bridge
  * debian/patches/include_config.h_in_all_files.patch:
    + Force inclusion of config.h where it isn't currently included, to
      ensure that important values such as object sizes are consistent.
      This ensures that the Chromium bridge doesn't break when built with
      -Bsymbolic-functions
  * debian/patches/use_AC_PATH_PROGS_to_satisfy_chromium_search.patch:
    + Use AC_PATH_PROGS, not multiple calls to AC_PATH_PROG, to search
      for a chromium binary, otherwise a cached "no" is used despite
      /usr/bin/chromium-browser existing
  * debian/rules:
    + Use --with-ff3 not --with-ff36, as the Xulrunner bridge is now 
      cross-version.

 -- Jo Shields <directhex@apebox.org>  Fri, 09 Jul 2010 07:34:51 +0100

=== debian/control ===
Source: moon
Section: web
Priority: optional
Maintainer: Moonlight packaging team <moonlight-team@lists.launchpad.net>
Uploaders: Jo Shields <directhex@apebox.org>
Homepage: http://www.mono-project.com/Moonlight
Vcs-Bzr: https://code.launchpad.net/~moonlight-team/+junk/master
Vcs-Browser: http://bazaar.launchpad.net/~moonlight-team/+junk/master/files
Standards-Version: 3.8.4
Build-Depends: debhelper (>= 7.0.50~), 
 xulrunner-dev (>= 1.9.2),
 libavcodec-dev, 
 cli-common-dev,
 libgtk2.0-dev, 
 libasound2-dev, 
 chrpath, 
 bison,
 zip,
 autoconf,
 automake,
 libtool,
 lsb-release, 
 libpulse-dev, 
 libcairo2-dev (>= 1.8),
 autoconf,
 automake,
 autotools-dev,
 libcurl4-gnutls-dev,
 libgtk2.0-cil-dev,
 libglade2.0-cil-dev,
 libglib2.0-cil-dev,
 libwnck1.0-cil-dev,
 libmono-cil-dev,
 libtool

Package: moonlight-plugin-core
Architecture: i386 lpia kfreebsd-i386 powerpc amd64 kfreebsd-amd64 ia64 arm armeb armel sparc s390
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: moonlight
Description: Free Software clone of Silverlight 2.0 - plugin core components
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains the core plugin components (for any browser)

Package: moonlight-plugin-mozilla
Architecture: i386 lpia kfreebsd-i386 powerpc amd64 kfreebsd-amd64 ia64 arm armeb armel sparc s390
Depends: ${shlibs:Depends}, moonlight-plugin-core (= ${binary:Version}), ${misc:Depends}
Recommends: firefox | abrowser | iceweasel | xulrunner-1.9.2
Conflicts: moonlight
Xb-Npp-Applications: ec8030f7-c20a-464f-9b0e-13a3a9e97384,92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a,aa5ca914-c309-495d-91cf-3141bbb04115
Xb-Npp-MimeType: application/x-silverlight,application/x-silverlight-2
Xb-Npp-Name: Novell Moonlight
Xb-Npp-File: libmoonloader.so
Xb-Npp-Description: Browser plugin for Silverlight 2.0 (http://www.mono-project.com/Moonlight)
Description: Free Software clone of Silverlight 2.0 - Xulrunner 1.9 plugin
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains the Xulrunner 1.9 plugin bridge, for full use with
 Xulrunner 1.9 browsers such as Firefox/Iceweasel 3, Epiphany-Gecko, HulaHop, 
 and others.

Package: moonlight-plugin-chromium
Architecture: i386 lpia kfreebsd-i386 powerpc amd64 kfreebsd-amd64 ia64 arm armeb armel sparc s390
Depends: ${shlibs:Depends}, moonlight-plugin-core (= ${binary:Version}), ${misc:Depends}
Recommends: chromium-browser
Conflicts: moonlight
Description: Free Software clone of Silverlight 2.0 - Chromium plugin
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains the Curl plugin bridge, for full use with the Chromium
 web browser.

Package: libmoon
Section: libs
Architecture: i386 lpia kfreebsd-i386 powerpc amd64 kfreebsd-amd64 ia64 arm armeb armel sparc s390
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Free Software clone of Silverlight 2.0 - unstable runtime library
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains required runtime files.

Package: monodoc-moonlight-manual
Section: libs
Architecture: all
Depends: monodoc-manual, ${misc:Depends}
Description: Free Software clone of Silverlight - desktop library documentation
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains the compiled XML documentation for Moonlight.Gtk
 of MonoDoc.

Package: libmoonlight-windows-desktop3.0-cil
Architecture: all
Depends: ${cli:Depends}, ${misc:Depends}
Description: Moonlight Moon.Windows.Desktop library
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains the Moon.Windows.Desktop assembly.

Package: libmoonlight-gtk3.0-cil
Architecture: all
Depends: ${cli:Depends}, ${misc:Depends}
Description: Moonlight.Gtk library
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains the Moonlight.Gtk assembly, for integrating Moonlight
 content into GTK# applications.

Package: libmoonlight-system-windows3.0-cil
Architecture: all
Depends: ${cli:Depends}, ${misc:Depends}
Description: Moonlight System.Windows libraries
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains the System.Windows assemblies.

Package: libmoonlight-system-windows-controls2.0-cil
Architecture: all
Depends: ${cli:Depends}, ${misc:Depends}
Description: Moonlight System.Windows.Controls libraries
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains the System.Windows.Controls assemblies.

Package: libmoonlight-desktop2.0-cil-dev
Architecture: all
Depends: 
 libmoonlight-system-windows-controls2.0-cil (= ${binary:Version}), 
 libmoonlight-system-windows3.0-cil (= ${binary:Version}), 
 libmoonlight-gtk3.0-cil (= ${binary:Version}),
 libmoonlight-windows-desktop3.0-cil (= ${binary:Version}),
 libgtk2.0-cil-dev,
 ${misc:Depends}
Suggests: monodoc-moonlight-manual
Description: Moonlight SDK for desktop apps
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains development files for writing desktop applications 
 with Moonlight, and should be used for compilation.

Package: moonlight-tools
Architecture: all
Depends: ${cli:Depends}, ${misc:Depends}
Description: Various tools for Moonlight SDK
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains development tools for Moonlight.

Package: moonlight-web-devel
Architecture: i386 lpia kfreebsd-i386 powerpc amd64 kfreebsd-amd64 ia64 arm armeb armel sparc s390
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: moonlight-tools
Description: Moonlight SDK for web apps
 Moonlight is a free Silverlight clone, allowing Free Software systems to
 run embedded web-browser objects or standalone code targetting Microsoft
 Silverlight.
 .
 About Microsoft Silverlight
 Microsoft Silverlight is a cross-browser, cross-platform, and cross-device
 plug-in for delivering the next generation of .NET based media experiences
 and rich interactive applications for the Web.
 .
 This package contains development files for writing web content with 
 Moonlight, and should be used for compilation.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export MONO_SHARED_DIR=$(CURDIR)
DEB_CLI_API_VERSION = 2.0
MAKEFILE = $(firstword $(MAKEFILE_LIST))
DEBIAN_DIR = $(dir $(MAKEFILE))
SOURCE_DIR = $(DEBIAN_DIR)/..

DEB_VERSION = $(shell dpkg-parsechangelog -l$(DEBIAN_DIR)/changelog | grep ^Version | cut -d" " -f2)   
DEB_SOURCE_NAME = $(shell dpkg-parsechangelog -l$(DEBIAN_DIR)/changelog | grep ^Source | cut -d" " -f2)
VERSION = $(shell echo $(DEB_VERSION) | cut -d"-" -f1 | sed 's/+dfsg.*//')

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH  ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
arch_config_args = --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE)
ifeq ($(DEB_HOST_ARCH),armel)
  arch_config_args += --with-fpu=VFP
endif

include /usr/share/cli-common/cli.make

clean:
	[ ! -f mono-2-6/Makefile ] || $(MAKE) -C mono-2-6 distclean
	[ ! -f mono-basic-2-6/Makefile ] || $(MAKE) -C mono-basic-2-6 clean
	[ ! -f Makefile ] || $(MAKE) clean
	rm -fr monoprefix
	rm -f *-stamp
	# distclean misses stuff
	#find is so fucking obtuse, i give up on it & declare grep my new master
	find . -name "Makefile" | grep -v 'mono-2-6\|mono-basic-2-6' | xargs rm -f
	find -name "*.mdb" -delete
	find -name ".stamp" -delete
	rm -f mono-basic-2-6/tools/moonlight/*.exe*
	rm -fr mono-basic-2-6/class/lib/2.1/
	rm -fr mono-basic-2-6/class/lib/moonlight/
	rm -fr mono-2-6/mcs/class/lib/net_*/
	rm -f src/xaml-to-header.exe*
	rm -rf mono-2-6/mcs/tools/csharplib/out
	rm -f class/Microsoft.SilverlightControls/Controls/Resource.resources
	rm -f mono-2-6/mcs/class/System.Web.Mvc/System.Web.Mvc/Resources/MvcResources.resources
	rm -f mono-2-6/mcs/class/Managed.Windows.Forms/resources/keyboards.resources
	rm -f mono-2-6/mcs/class/Mono.Data.Sqlite/resources/SR.resources
	rm -f mono-basic-2-6/vbnc/vbnc/vbnc.vbnc.rsp
	rm -f mono-2-6/mcs/class/Novell.Directory.Ldap/Novell.Directory.Ldap.Utilclass/ResultCodeMessages.resources
	rm -f mono-2-6/mcs/class/System.Web/resources/TranslationResources.resources
	rm -f mono-2-6/mcs/class/Commons.Xml.Relaxng/Commons.Xml.Relaxng.Rnc/RncParser.cs
	rm -f mono-2-6/mcs/class/Commons.Xml.Relaxng/y.output
	rm -f mono-2-6/mcs/class/Mono.WebBrowser/Mono.WebBrowser2K5.csproj
	rm -f class/System.Windows.Controls/*.resources
	rm -f mono-2-6/mcs/class/System.Data/Mono.Data.SqlExpressions/Parser.cs
	rm -f mono-2-6/mcs/class/System.Web/System.Web/UplevelHelper.cs
	rm -f mono-2-6/mcs/class/System.XML/Mono.Xml.Xsl/PatternParser.jay
	rm -f mono-2-6/mcs/class/corlib/net_1_1_aot.log
	rm -rf mono-2-6/mcs/build/deps/
	rm -f mono-2-6/dolt*
	rm -f stamp-h1
	rm -f config.h config.log config.status dolt* libtool
	rm -f mono-2-6/mcs/build/config.make
	rm -f plugin/install/install.rdf plugin/silverlight-versions.h
	rm -f tools/sockpol/sockpol
	rm -f moon.pc moonlight.spec
	rm -f src/codec-version.h src/drm.h src/fullscreen.h src/incomplete-support.h
	dh_prep
	dh_clean

configure: mono-install-stamp moonlight-configure-stamp

build: mono-build-stamp moonlight-build-stamp
	touch build-stamp

build-indep: build-stamp

build-arch: build-stamp

install-stamp: moonlight-build-stamp
	dh_testdir
	dh_testroot
	dh_installdirs
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install
	install -m 644 monoprefix/lib/libmono.so.0.0.0  debian/tmp/usr/lib/moonlight/
	install -m 755 monoprefix/bin/mono  debian/tmp/usr/lib/moonlight/
	chrpath -r /usr/lib/moonlight/ $(MONO_SHARED_DIR)/debian/tmp/usr/lib/libmoon.so.0.0.0
	chrpath -r /usr/lib/moonlight/ $(MONO_SHARED_DIR)/debian/tmp/usr/lib/moonlight/plugin/libmoonplugin.so
	dh_install --list-missing
	touch install-stamp

mono-install-stamp: mono-build-stamp
	cd mono-2-6 && $(MAKE) install

	#manually insert GTK# into monoprefix GAC
	$(MONO_SHARED_DIR)/monoprefix/bin/gacutil -i /usr/lib/cli/gtk-sharp-2.0/gtk-sharp.dll
	$(MONO_SHARED_DIR)/monoprefix/bin/gacutil -i /usr/lib/cli/atk-sharp-2.0/atk-sharp.dll
	$(MONO_SHARED_DIR)/monoprefix/bin/gacutil -i /usr/lib/cli/gdk-sharp-2.0/gdk-sharp.dll
	$(MONO_SHARED_DIR)/monoprefix/bin/gacutil -i /usr/lib/cli/glib-sharp-2.0/glib-sharp.dll
	$(MONO_SHARED_DIR)/monoprefix/bin/gacutil -i /usr/lib/cli/gtk-dotnet-2.0/gtk-dotnet.dll
	$(MONO_SHARED_DIR)/monoprefix/bin/gacutil -i /usr/lib/cli/pango-sharp-2.0/pango-sharp.dll

	touch mono-install-stamp

mono-build-stamp: mono-configure-stamp
	cd mono-2-6 && $(MAKE)
	touch mono-build-stamp

mono-configure-stamp:
	cd mono-2-6 && ./configure --prefix=$(MONO_SHARED_DIR)/monoprefix $(arch_config_args)
	touch mono-configure-stamp

moonlight-build-stamp: moonlight-configure-stamp
	PATH=$(MONO_SHARED_DIR)/monoprefix/bin:$(PATH) $(MAKE)
	touch moonlight-build-stamp	

moonlight-configure-stamp: mono-install-stamp
	autoreconf
	PKG_CONFIG_PATH=$(MONO_SHARED_DIR)/monoprefix/lib/pkgconfig ./configure --with-mcspath=$(MONO_SHARED_DIR)/mono-2-6/mcs --with-mono-basic-path=$(MONO_SHARED_DIR)/mono-basic-2-6 --with-cairo=system --with-ff3=yes --prefix=/usr --with-curl=system $(arch_config_args)
	touch moonlight-configure-stamp

get-orig-source:
	uscan \
		--package $(DEB_SOURCE_NAME) \
		--watchfile $(DEBIAN_DIR)/watch \
		--upstream-version $(VERSION) \
		--download-version $(VERSION) \
		--destdir . \
		--force-download \
		--rename
	wget -c http://ftp.novell.com/pub/mono/sources/moon/$(VERSION)/mono-2.6.1.tar.bz2 
	wget -c http://ftp.novell.com/pub/mono/sources/moon/$(VERSION)/mono-basic-2.6.tar.bz2 
	mv mono-2.6.1.tar.bz2 ./moon_$(VERSION).orig-mono-2-6.tar.bz2
	mv mono-basic-2.6.tar.bz2 ./moon_$(VERSION).orig-mono-basic-2-6.tar.bz2

binary: install-stamp

binary-arch: install-stamp

override_dh_makeshlibs:
	dh_makeshlibs
	dh_makeshlibs -p libmoon -V'libmoon (>= $(VERSION)), libmoon (<< $(VERSION).)'

override_dh_makeclilibs:
	dh_makeclilibs -V

%:
	dh $@

.PHONY: build build-arch build-indep
